#!/usr/bin/perl

# Affiliate Master  Copyright 1999 by Allen Says

########################################
###### START OF CONFIGURATION AREA #####
########################################

# full URL to commissions_admin.cgi
$admin_cgi_url = "http://www.yourdomain.com/cgi-bin/commissions_admin.cgi";

# user database file
$resellerdb = "resellerdb.txt";

# name of admin password file for logging into system
$adminpasswordfile = "adminpass.txt";

#####################################
##### END OF CONFIGURATION AREA #####
#####################################











$MONTH{'01'} = "January";
$MONTH{'02'} = "February";
$MONTH{'03'} = "March";
$MONTH{'04'} = "April";
$MONTH{'05'} = "May";
$MONTH{'06'} = "June";
$MONTH{'07'} = "July";
$MONTH{'08'} = "August";
$MONTH{'09'} = "September";
$MONTH{'10'} = "October";
$MONTH{'11'} = "November";
$MONTH{'12'} = "December";


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
   ($name, $value) = split(/=/, $pair);

   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<([^>]|\n)*>//g;
   $value =~ s/<//g;
   $value =~ s/>//g;
   $FORM{$name} = $value;
}

if ($FORM{'view_menu'}) {&view_menu; }
elsif ($FORM{'set_password'}) {&set_password; }
elsif ($FORM{'admin_login_check_password'}) {&admin_login_check_password; }
elsif ($FORM{'current_month'}) {&view_commissions; }
elsif ($FORM{'last_month'}) {&view_commissions; }
elsif ($FORM{'customize'}) {&view_commissions; }
else { &admin_login; }

exit;


sub view_commissions
{
   &verify_required_fields;
   &find_member_info;
   &get_date;
   &determine_date_range;
   &display_commissions;
}


######################################################
### sub  verify_required_fields
###
###   Will verify that all required fields have been entered
######################################################
sub verify_required_fields
{
   $number_required = @required_fields;
   $found_in_list = 0;
   $missing_something = 0;

   for ($counter = 0; $counter < $number_required; $counter++)
   {
      $check = $required_fields[$counter];
      $check =~ s/^\s+//g;
      $check =~ s/\s+$//g;

      if ($FORM{$check} eq '')
      {
         if ($missing_something == 0) { &print_missing_header; $missing_something = 1; }
         print "<font color=blue><li> <b>$check</b></font><br>\n";
      }
   }

   if ($missing_something == 1)
   {
      print "<BR><b>Please hit your browser's \"back\" button and enter required information.</b></center><br>\n";
      exit;
   }

}

sub print_missing_header
{
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ooops, You Forgot To Enter Some Data!</title></head>\n";
   print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
   print "<b>Ooops, You Forgot To Enter Some Data</b></font><br><br>\n";
   print "<b>The following fields are required:</b><p>\n";
}


sub find_member_info
{
   my ($match, $line, @lines);

   open(FILE2, "$resellerdb") or return;
   flock (FILE2, 2);
   @lines = <FILE2>;
   close (FILE2);

   $match = 0;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;

      %VERIFY = &breakup_line($line);

      if($VERIFY{'idnumber'} eq $FORM{'idnumber'})
      {
         $match = 1;
         &set_member_info;
         last;
      }
   }
}

sub set_member_info
{
   $FORM{'sponsorfullname'} = $VERIFY{'fullname'};
   $FORM{'sponsoremail'} = $VERIFY{'email'};
}


sub breakup_line
{
   my ($input) = @_;
   my (%DATA);

   ($DATA{'idnumber'},$DATA{'sponsorid'},$DATA{'fullname'},$DATA{'email'}) = split(/&&/, $input);
   return %DATA;
}


######################################################
### sub  get_date
###
###   Gets the current date
######################################################
sub get_date
{
   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $mon = $mon + 1;
   if ($mon < 10)
   {
      $mon = "0$mon";
   }

   if ($mday < 10)
   {
      $mday = "0$mday";
   }

   $year = $year + 1900;

   $thedate = "$year$mon$mday";
   $FORM{'thedate'} = "$year$mon$mday";
}


sub determine_date_range
{
   if ($FORM{'current_month'})
   {
      $FORM{'heading'} = "Commissions for the current month of <b>$MONTH{substr($thedate, 4, 2)}, " . substr($thedate, 0, 4) . "</b>";
      $from_date = substr($thedate, 0, 4) . substr($thedate, 4, 2);
   }
   elsif ($FORM{'last_month'})
   {
      $the_month = substr($thedate, 4, 2) - 1;
      $the_year = substr($thedate, 0, 4);
      if ($the_month < 10)
      {
         $the_month = "0$the_month";
      }

      if ($the_month == 0)
      {
         $the_month = 12;
         $the_year = $the_year - 1;
      }

      $FORM{'heading'} = "Commissions for the previous month of <b>$MONTH{$the_month}, $the_year</b>";

      $from_date = $the_year . $the_month;
   }
   else
   {
      if ($FORM{'from_month'} ne "")
      {
         $from_date = $FORM{'from_year'} . $FORM{'from_month'};
      }
      else
      {
         $from_date = substr($thedate, 0, 4) . substr($thedate, 4, 2);
      }

      $the_year = substr($from_date, 0, 4);

      $FORM{'heading'} = "Commissions for the month of <b>$MONTH{substr($from_date, 4, 2)}, $the_year</b>";
   }
}


sub display_commissions
{
   $commissions_file = "$from_date.txt";

   open(FILE,$commissions_file);
   @lines = <FILE>;
   close(FILE);

   open(FILE2, "$resellerdb");
   flock (FILE2, 2);
   @resellers = <FILE2>;
   close (FILE2);

   $total_orderamt = 0;
   $total_commissions = 0;
   $total_orders = 0;

   $reseller_total_commissions = 0;
   $reseller_total_orderamt = 0;
   $reseller_total_orders = 0;

   print "Content-type: text/html\n\n";

   &display_header;

   foreach $reseller (@resellers)
   {
      $reseller =~ s/\n//g;
      $reseller =~ s/\r//g;

      %FORM = &breakup_line($reseller);

      foreach $line (@lines)
      {
         $line =~ s/\n//g;
         $line =~ s/\r//g;
         ($sponsorid, $saledate, $ordernumber, $orderamt, $commission) = split(/\&\&/, $line);

         if ($FORM{'idnumber'} eq $sponsorid)
         {
            if ($display_table_now == 0) {
               $display_table_now = 1;
               &display_table_header;  }
            &display_record;
         }
      }

      if ($display_table_now == 1)  {
      &display_table_trailer;  }
   }

   &display_trailer;
}

sub display_header
{

print qq|
<html><head><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Sales &amp; Commissions Report</title></head>

<body><p align="center"><font face="Arial" color="#0000FF"><big><strong>Online Sales &amp;
Commissions Report</strong></big></font></p>

<p align="center"><strong><font face="Arial">$FORM{'heading'}</font></strong></p>
|;
}

sub display_table_header
{
print qq|
<div align="center"><center>
<table border="2" cellpadding="0" cellspacing="0" width="550" bgcolor="#DEDEDE">
  <tr>
    <td align="center"><small><font face="Arial" color="#0000FF"><strong>Date of Sale</strong></font></small></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Order #
    </strong></font></small></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Order
    Amount</strong></font></small></td>
    <td align="center" height="16"><font face="Arial" color="#0000FF"><small><strong>Commissions</strong></small></font></td>
    <td align="center" height="16"><small><font face="Arial" color="#0000FF"><strong>Reseller ID
    </strong></font></small></td>
  </tr>
|;
}

sub display_record
{
   $saledate = &reformat_date($saledate);

   $total_commissions = $total_commissions + $commission;
   $total_orderamt = $total_orderamt + $orderamt;
   $total_orders++;

   $reseller_total_commissions = $reseller_total_commissions + $commission;
   $reseller_total_orderamt = $reseller_total_orderamt + $orderamt;
   $reseller_total_orders++;

   $commission = sprintf("%.2f", $commission);
   $orderamt = sprintf("%.2f", $orderamt);

   print qq|<tr><td align="center" width="100"><small><font face="Arial">&nbsp;$saledate&nbsp;</font></small></td>
                <td align="center" width="100"><small><font face="Arial">&nbsp;$ordernumber&nbsp;</font></small></td>
                <td align="right" width="100"><small><font face="Arial">&nbsp;\$$orderamt&nbsp;&nbsp;</font></small></td>
                <td align="right" width="100"><small><font face="Arial">&nbsp;\$$commission&nbsp;&nbsp;</font></small></td>
                <td align="center" width="100"><small><font face="Arial">&nbsp;$sponsorid&nbsp;</font></small></td></tr>|;
}

sub display_table_trailer
{
   $reseller_total_commissions = sprintf("%.2f", $reseller_total_commissions);
   $reseller_total_orderamt = sprintf("%.2f", $reseller_total_orderamt);

   print qq|<tr><td bgcolor="#BDBDFF" align="center" width="100"><small><font face="Arial">&nbsp;</font></small></td>
                <td bgcolor="#BDBDFF" align="center" width="100"><small><font face="Arial">&nbsp;</font></small></td>
                <td bgcolor="#BDBDFF" align="right" width="100"><small><strong><font face="Arial">&nbsp;\$$reseller_total_orderamt&nbsp;&nbsp;</font></strong></small></td>
                <td bgcolor="#BDBDFF" align="right" width="100"><small><strong><font face="Arial">&nbsp;\$$reseller_total_commissions&nbsp;&nbsp;</font></strong></small></td>
                <td bgcolor="#BDBDFF" align="center" width="100"><small><strong><font face="Arial">&nbsp;$FORM{'idnumber'}&nbsp;</font></strong></small></td></tr></tr></table></center></div>|;

   $reseller_total_commissions = 0;
   $reseller_total_orderamt = 0;
   $reseller_total_orders = 0;
   $display_table_now = 0;

}

sub display_trailer
{

   $total_orderamt = sprintf("%.2f", $total_orderamt);
   $total_commissions = sprintf("%.2f", $total_commissions);


print qq|</tr></table></center></div>

<br>&nbsp;
<div align="center"><center>

<table border="2" cellpadding="0" cellspacing="0" width="250" bgcolor="#DEDEDE">
  <tr>
    <td width="150"><font face="Arial" color="#0000FF"><small><strong>Total # Orders</strong></small></font></td>
    <td align="right" width="100">&nbsp;<b>$total_orders</b>&nbsp;&nbsp;</td>
  </tr>
  <tr>
    <td width="100"><font face="Arial" color="#0000FF"><small><strong>Total Order Amount</strong></small></font></td>
    <td align="right" width="100">&nbsp;<b>\$$total_orderamt</b>&nbsp;&nbsp;</td>
  </tr>
  <tr>
    <td><small><font face="Arial" color="#0000FF"><strong>Total Commissions</strong></font></small></td>
    <td align="right">&nbsp;<b>\$$total_commissions</b>&nbsp;&nbsp;</td>
  </tr>
</table>
</center></div>


|;
}

sub reformat_date
{
   my ($input) = @_;
   $formatted_date = substr($input, 4, 2) . "/" . substr($input, 6, 2) . "/" . substr($input, 2, 2);
   return $formatted_date;
}


sub cgierr {
# --------------------------------------------------------
# Displays any errors and prints out FORM and ENVIRONMENT
# information. Useful for debugging.

	if (!$html_headers_printed) {
		print "Content-type: text/plain\n\n";
		$html_headers_printed = 1;
	}
	print "<PRE>\nCGI Error: $!\n";
	print "Message: $_[0]\n\n";
	print "_________Form Variables __________\n";
	foreach $key (sort keys %in) {
		print "$key: \t$in{$key}\n";
	}

	print "\n_________Environment Variables__________\n";
	foreach $env (sort keys %ENV) {
		print "$env: \t$ENV{$env}\n";
	}
	print "\n</PRE>";
	exit;
}


######################################################
### sub admin_login
###
###    Display Admin Main Menu
######################################################
sub admin_login
{
   unless (-e "$adminpasswordfile")
   {
      &set_admin_password;
   }

   &get_admin_pass;
}


sub set_admin_password
{
   print "Content-type: text/html\n\n";
   &display_headline_custom ("Set Administration Password");

   print qq!<form method="POST" action="$admin_cgi_url">
   <input type="hidden" name="required_fields" value="password,password2">
   <div align="center"><center><table border="0" cellpadding="4" width="450"><tr>
   <td><font face="Verdana" size="2">The password file was not located.&nbsp; You
   should now set the administration password.&nbsp; This password will be used to log into
   the Affiliate Master Sales and Commissions Admin Area.</font></td></tr></table></center></div><div align="center"><center><table border="0" cellpadding="4" width="450">
   <tr><td width="149" align="right"><font face="Verdana" size="2"><strong>enter password</strong> </font></td>      <td width="281"><input type="password" name="password" size="20"></td>
   </tr><tr><td width="149" align="right"><font face="Verdana" size="2"><strong>confirm password</strong> </font></td>
   <td width="281"><input type="password" name="password2" size="20"></td></tr></table>
   </center></div><div align="center"><center><p><font face="Verdana" size="2"><input
   type="submit" value="  Set Password  " name="set_password"><input type="reset" value="Reset" name="reset"></font></p></center></div></form>!;

   exit;
}

sub set_password
{
   &verify_required_fields;

   if ($FORM{'password'} ne $FORM{'password2'})
   {
      print "Content-type: text/html\n\n";
      print qq|<html><head><title>Ooops, The Passwords Don't Match!</title></head>
             <body bgcolor=white><br><center><font size=5 face="Verdana" color=blue>
             <b>Ooops, The Passwords Don't Match!</b></font><br><br>
             <font face="Verdana" size="2">The passwords must match in order to set the administration password.</font><p>
             <font face="Verdana" size="2"><b>Please hit your browser's \"back\" button and re-enter the passwords.</font></b></center><br>|;
      &admin_display_trailer_line;
      exit;
   }

   chop ($FORM{'password'}) if ($FORM{'password'} =~ /\n$/);
   $newpassword = crypt($FORM{'password'}, aa);

   open (PASSWORD, ">$adminpasswordfile")
      or &cgierr("error in set_password. unable to open user file: $CONFIG{'adminpasswordfile'}. Reason: $!");
   flock(PASSWORD,2);
   print PASSWORD "$newpassword";
   close (PASSWORD);
   &get_admin_pass;
   exit;
}

sub get_admin_pass
{
   print "Content-type: text/html\n\n";
   &display_headline_custom ("Enter Administration Password");

   print qq!
   <form method="POST" action="$admin_cgi_url">
   <input type="hidden" name="required_fields" value="password">
   <div align="center"><center><table border="0" cellpadding="4" width="450"><tr>
   <td><font face="Verdana" size="2">The Administration area is restricted to autorized users only.  Please enter the Administration password.</font></td></tr></table></center></div><div align="center"><center><table border="0" cellpadding="4" width="450">
   <tr><td width="149" align="right"><font face="Verdana" size="2"><strong>enter password</strong> </font></td>      <td width="281"><input type="password" name="password" size="20"></td>
   </tr></table></center></div><div align="center"><center><p><font face="Verdana" size="2"><input
   type="submit" value="  Admin Login  " name="admin_login_check_password"><input type="reset" value="Reset" name="reset"></font></p></center></div></form>!;

   exit;
}


sub display_headline_custom
{
   my ($display_this) = @_;

   print qq!<p>&nbsp;</p><div align="center"><center><table border="0" cellpadding="4" width="450" bgcolor="#C0C0C0"><tr>
   <td><div align="center"><center><p><font face="Arial Black" color="#0000FF"><strong>
   $display_this</strong></font></td></tr></table></center></div>!;
}


sub admin_login_check_password
{
   &verify_required_fields;

   open (PASSWORD, "$adminpasswordfile");
   flock(PASSWORD,2);
   $password = <PASSWORD>;
   close (PASSWORD);

   chop ($password) if ($password =~ /\n$/);
   $newpassword = crypt($FORM{'password'}, aa);

   unless ($newpassword eq $password)
   {
      &user_error ("The admin Password is invalid or does not match.");
      exit;
   }

   &view_menu;
   exit;
}

sub user_error
{
   my ($user_error) = $_[0];
   print "Content-type: text/html\n\n";
   print "<html><head><title>Ooops, An Error Has Occured!</title></head>\n";
   print "<body bgcolor=white><br><center><font size=5 color=blue>\n";
   print "<b>$user_error</b></font><br><br>\n";
   print "<BR><b>Please hit your browser's \"back\" button and change the required field(s).</b></center><br>\n";
   exit;
}


sub view_menu
{
   print "Content-type: text/html\n\n";

print qq|
<html>

<head>
<title>Affiliate Master Admin Sales and Commissions</title>
</head>

<body>

<p align="center"><strong><font face="Verdana" color="#000080"><em><big>Affiliate Master</big><br>
</em></font><small><font face="Verdana" color="#000000">Reseller's Sales and Commissions</font></small></strong></p>

<form method="POST"
action="$admin_cgi_url">
  <div align="center"><center><table border="1" cellpadding="2" cellspacing="0" width="500"
  bgcolor="#DEDEDE" height="203">
    <tr align="center">
      <td width="158" align="right" height="25"><div align="center"><center><p><small><strong><font

      face="Verdana"><input type="submit" value="Current" name="current_month"> </font></strong></small></td>
      <td width="338" height="25" align="left"><small><strong><font face="Verdana">&nbsp;Display
      Current Month's Commissions</font></strong></small></td>
    </tr>
    <tr align="center">
      <td width="158" align="right" height="26"><div align="center"><center><p><small><strong><font

      face="Verdana"><input type="submit" value="Previous" name="last_month"> </font></strong></small></td>
      <td width="338" height="26" align="left"><small><strong><font face="Verdana">&nbsp;Display
      Previous Month's Commissions</font></strong></small></td>
    </tr>
    <tr align="center">
      <td width="158" align="right" height="19">&nbsp;&nbsp; </td>
      <td width="338" height="19">&nbsp;&nbsp; </td>
    </tr>
    <tr align="center">
      <td width="158" align="right" height="24"><div align="center"><center><p><select

      name="from_month" size="1">
        <option value="01">January</option>
        <option value="02">February</option>
        <option value="03">March</option>
        <option value="04">April</option>
        <option value="05">May</option>
        <option value="06">June</option>
        <option value="07">July</option>
        <option value="08">August</option>
        <option value="09">September</option>
        <option value="10">October</option>
        <option value="11">November</option>
        <option value="12">December</option>
      </select></td>
      <td width="338" height="24" align="left"><small><font face="Verdana"><strong>&nbsp;Choose
      Month</strong></font></small></td>
    </tr>
    <tr align="center">
      <td width="158" align="right" height="24"><div align="center"><center><p><select

      name="from_year" size="1">
        <option value="1998">1998</option>
        <option value="1999">1999</option>
        <option value="2000">2000</option>
        <option value="2001">2001</option>
        <option value="2002">2002</option>
        <option value="2003">2003</option>
      </select></td>
      <td width="338" height="24" align="left"><small><font face="Verdana"><strong>&nbsp;Choose
      Year</strong></font></small></td>
    </tr>
    <tr align="center">
      <td width="158" align="right" height="25"><small><strong><font face="Verdana"><div

      align="center"><center><p><input type="submit" value="Selected" name="customize"></font></strong></small></td>
      <td width="338" height="25" align="left"><small><strong><font face="Verdana">&nbsp;Display
      Selected Month/Year</font></strong></small></td>
    </tr>
  </table>
  </center></div>
</form>

<p align="center">&nbsp;</p>
</body>
</html>
|;

}
