#! /usr/bin/perl
# change to valid path to perl

# Affiliate Master  Copyright 1999 by Allen Says

########################################
###### START OF CONFIGURATION AREA #####
########################################

# which webpage this to display if webpage name is not passed to script
$webpage_to_display = "index.html";

# user database file
$resellerdb = "resellerdb.txt";

#####################################
##### END OF CONFIGURATION AREA #####
#####################################











# gets users id and/or webpage name from command line
if ($ENV{'QUERY_STRING'} ne '') {
   ($idnumber, $webpage) = split(/=/, $ENV{'QUERY_STRING'}); }
elsif ($ENV{'PATH_INFO'} ne '') {
   ($trash, $idnumber, $webpage) = split(/\//, $ENV{'PATH_INFO'}); }

# determine which webpage to display
if ($webpage ne "") {
   $webpage_to_display = $webpage;  }

# open webpage for reading
open(TEMPLATE, "<$webpage_to_display");
@lines=<TEMPLATE>;
close (TEMPLATE);

# look up user in reseller db file
&find_member_info;

# display webpage, replacing [IDNUMBER] with the passed id number
print "Content-type: text/html\n\n";
foreach $temp (@lines)
{
   foreach $key (keys(%FORM))
   {
      $temp =~ s/\[$key\]/$FORM{$key}/gi;
   }

#  $temp =~ s/\[IDNUMBER\]/$idnumber/gi;
  print $temp;
}

# exit the program
exit;


sub find_member_info
{
   my ($match, $line, @lines);

   open(FILE2, "$resellerdb") or return;
   flock (FILE2, 2);
   @lines = <FILE2>;
   close (FILE2);

   $match = 0;

   foreach $line (@lines)
   {
      $line =~ s/\n//g;
      $line =~ s/\r//g;

      %FORM = &breakup_line($line);

      if($FORM{'idnumber'} eq $idnumber)
      {
         $match = 1;
         last;
      }
   }
}

sub breakup_line
{
   my ($input) = @_;
   my (%DATA);

   ($DATA{'idnumber'},$DATA{'sponsorid'},$DATA{'fullname'},$DATA{'email'}) = split(/&&/, $input);
   return %DATA;
}
